/*
* File:     help.c
* Author:   Michael Chinn
* UDel ID:  mechinn
*/

#include <stdio.h>
#include <string.h>

#include "help.h"
//help documentation for user
void help(int argc, char **argv) {
    if (argc==1) { //if the user did not specify what they want help on
        printf("This is the help documentation to Michael Chinn's Little Shell for Project 1 in CISC361\n"
                "You can get specific help by running the command \"help commandName\"\n"
                "\n"
                "help <command>\n"
                "exit\n"
                "which command1 <command2 ...W>\n"
                "where command/alias1 <command/alias2 ...>\n"
                "cd <path/->\n"
                "pwd\n"
                "list <path1> <path2 ...>\n"
                "pid\n"
                "kill <-sig> pid\n"
                "prompt <promptPrefix>\n"
                "printenv <environmentVariable>\n"
                "alias <aliasName aliasCommand>\n"
                "history <#lines>\n"
                "setenv <environmentVariable> <variableValue>\n");
    } else if(argc==2) { // if they specified what they want help on give them help on that internal command
        if (!strncmp(argv[1],"help",4)) {
            printf("help:\n"
                    "\n"
                    "Usage:\n"
                    "help <command>\n"
                    "\n"
                    "Description:\n"
                    "Gives the help documentation to the my shell or to the specific internal command in the shell\n");
        } else if (!strncmp(argv[1],"exit",4)) {
            printf("exit:\n\n"
                    "Usage:\n"
                    "exit\n\n"
                    "Description:\n"
                    "obvious\n");
        } else if (!strncmp(argv[1],"which",5)) {
            printf("which:\n"
                    "\n"
                    "Usage:\n"
                    "which command1 <command2 ...>\n"
                    "\n"
                    "Description:\n"
                    "same as the tcsh one (hint: you can write a function to do this \n"
                    "and use it for finding the command to execute)\n");
        } else if (!strncmp(argv[1],"where",5)) {
            printf("where:\n"
                    "\n"
                    "Usage:\n"
                    "where command/alias1 <command/alias2 ...>\n"
                    "\n"
                    "Description:\n"
                    "same as the tcsh one\n");
        } else if (!strncmp(argv[1],"cd",2)) {
            printf("cd:\n"
                    "\n"
                    "Usage:\n"
                    "cd <path/->\n"
                    "\n"
                    "Description:\n"
                    "chdir(2) to directory given, with no arguments chdir to home dir,\n"
                    "with a '-' as the only argument chdirs to directory previously in, the same as tcsh does.\n");
        } else if (!strncmp(argv[1],"pwd",3)) {
            printf("pwd:\n"
                    "\n"
                    "Usage:\n"
                    "pwd\n"
                    "\n"
                    "Description:\n"
                    "print the current working dir.\n");
        } else if (!strncmp(argv[1],"list",4)) {
            printf("list:\n"
                    "\n"
                    "Usage:\n"
                    "list <path1 path2 ...>\n"
                    "\n"
                    "Description:\n"
                    "with no arguments lists the files in the current directory one per line. With arguments\n"
                    "lists the files in each directory given as an argument, with a blank line then the name of the\n"
                    "directory followed by a : before the list of files in that dir. You will need to use opendir(3C)\n"
                    "and readdir(3C). (hint: read their man pages carefully.)\n");
        } else if (!strncmp(argv[1],"pid",3)) {
            printf("pid:\n"
                    "\n"
                    "Usage:\n"
                    "pid\n"
                    "\n"
                    "Description:\n"
                    "prints the pid of the shell\n");
        } else if (!strncmp(argv[1],"kill",4)) {
            printf("kill:\n"
                    "\n"
                    "Usage:\n"
                    "kill <-sig> pid\n"
                    "\n"
                    "Description:\n"
                    "When given just a pid sends a SIGTERM to it with kill(2). When given a signal number\n"
                    "(with a - in front of it) sends that signal to the pid. (ex. kill 5678, kill -9 5678).\n");
        } else if (!strncmp(argv[1],"prompt",6)) {
            printf("prompt:\n"
                    "\n"
                    "Usage:\n"
                    "prompt <promptPrefix>\n"
                    "\n"
                    "Description:\n"
                    "When ran with no arguments prompts for a new prompt prefix string.\n"
                    "When given an argument make that the new prompt prefix.\n");
        } else if (!strncmp(argv[1],"printenv",8)) {
            printf("printenv:\n"
                    "\n"
                    "Usage:\n"
                    "printenv <environmentVariable>\n"
                    "\n"
                    "Description:\n"
                    "Should work the same as the tcsh builtin one. When ran with no arguments prints the\n"
                    "whole environment (This can be done in 2 lines of code, a printf() inside of a while loop,\n"
                    "not counting a variable declaration). When ran with one argument, call getenv(3C) on it.\n"
                    "When called with two or more args print the same error message to stderr that tcsh does.\n");
        } else if (!strncmp(argv[1],"alias",5)) {
            printf("alias:\n"
                    "\n"
                    "Usage:\n"
                    "alias <aliasName aliasCommand>\n"
                    "\n"
                    "Description:\n"
                    "Should work the same as the tcsh builtin one. When ran with no arguments prints the\n"
                    "aliases the shell knows about. When ran with arguments it should install an alias into the\n"
                    "alias table the shell knows about. Additionally, the shell needs to be able to run your\n"
                    "aliases to receive full credit. Supply your own test cases to show that it works.\n");
        } else if (!strncmp(argv[1],"history",7)) {
            printf("history:\n"
                    "\n"
                    "Usage:\n"
                    "history <#lines>\n"
                    "\n"
                    "Description:\n"
                    "Should print the last n commands (by default n is 10) executed when ran with no options.\n"
                    "When ran with a numerical argument changes the number of commands to list to that number.\n");
        } else if (!strncmp(argv[1],"setenv",6)) {
            printf("setenv:\n"
                    "\n"
                    "Usage:\n"
                    "setenv <environmentVariable> <variableValue>\n"
                    "\n"
                    "Description:\n"
                    "Should work the same as the tcsh builtin one. When ran with no arguments prints the whole environment,\n"
                    "the same as a printenv. When ran with one argument sets that as an empty environment variable.\n"
                    "When ran with two arguments the second one is the value of the first. When ran with more args print\n"
                    "the same error message to stderr that tcsh does. You can use the putenv(3C) function for this command.\n"
                    "Special care must be given when PATH and HOME are changed. When PATH is changed be sure to update your\n"
                    "linked list for the path directories (and free() up the old one). When HOME is changed cd with no arguments\n"
                    "should now go to the new home. Provide your own test runs to show this works.\n");
        }
    } else { //they did it wrong!
        printf("Usage: help <internal command>");
    }
}
