/*
* File:     list.c
* Author:   Michael Chinn
* UDel ID:  mechinn
*/

/*
 * with no arguments lists the files in the current directory one per
 * line. With arguments lists the files in each directory given as an
 * argument, with a blank line then the name of the directory followed
 * by a : before the list of files in that dir.
 * You will need to use opendir(3C) and readdir(3C)
 */

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>

#include "list.h"

void list(int argc, char **argv) {
    //create variables
    DIR *directory;
    struct dirent *dp;
    if (argc>1) {// if "list paths"
        int i=1;
        for (;i<argc;++i){ // go through the arguments
            if ((directory = opendir(argv[i]))==NULL) { //try to open the directory
                perror("opendir");
            } else {
                printf("\n%s:\n",argv[i]);
                //go through the directory and print out each item
                while ((dp = readdir(directory)) != NULL) { 
                    printf("%s\n",dp->d_name);
                }
                closedir(directory); //close the directory
            }
        }
    } else {
        if ((directory = opendir("."))==NULL) {
            perror("opendir");
        } else {
            while ((dp = readdir(directory)) != NULL) {
                printf("%s\n",dp->d_name);
            }
            closedir(directory);
        }
    }
}
