/*
* File:     history.c
* Author:   Michael Chinn
* UDel ID:  mechinn
*/

/*
 * Should print the last n commands (by default n is 10) executed when
 * ran with no options. When ran with a numerical argument changes
 * the number of commands to list to that number
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "myHistory.h"

// print history based on count given or default 10
void myHistory(int argc, char **argv) {
    if(!myHistoryHead) {
        printf("No History\n"); //if there is no history somehow tell the user there isnt any (just in case)
    } else {
        struct myHistoryList *temp = myHistoryHead;
        int i = 0;
        int num = 10;
        if(argc>1){
            num = atoi(argv[1]); //if the user asked for a certain amount of history do that
        }
        //print history
        while (temp&&i<num){
            printf("%s\n",temp->element);
            temp = temp->next;
            ++i;
        }
    }
}

// add command to front of history linked list
void addMyHistory(char* command) {
    if(strcmp(command,"\n")){
        struct myHistoryList *temp; //create a temp linked list value

        temp=(struct myHistoryList *)malloc(sizeof(struct myHistoryList));
        temp->element = malloc(strlen(command)*sizeof(char));
        strcpy(temp->element,strtok(command,"\n"));

        if (myHistoryHead == NULL){
            //List is Empty
            myHistoryHead=temp;
            myHistoryHead->next=NULL;
        } else {
            temp->next=myHistoryHead;
            myHistoryHead=temp;
        }
    }
}

// free history memory
void freeMyHistory() {
   struct myHistoryList *temp;
   while( myHistoryHead != NULL ) {
      temp = myHistoryHead->next;
      free (myHistoryHead->element);
      free( myHistoryHead );
      myHistoryHead = temp;
   }
}
