/*
* File:     printenv.c
* Author:   Michael Chinn
* UDel ID:  mechinn
*/

/*
 * Should work the same as the tcsh builtin one. When ran with no
 * arguments prints the whole environment (This can be done in 2
 * lines of code, a printf() inside of a while loop, not counting a
 * variable declaration). When ran with one argument, call getenv(3C)
 * on it. When called with two or more args print the same error
 * message to stderr that tcsh does
 */

#include <stdio.h>
#include <stdlib.h>

#include "printenv.h"
//print out the environment
void printEnv(int argc, char **argv, char** envp) {
    if(argc==1){ //if just printenv print whole environment
        int i=0;
        while(envp[i]){
            printf("%s\n",envp[i]);
            i++;
        }
    } else if(argc==2){ //if specific environment variable print that environment variable
        printf("%s=\n",argv[1]);
        printf("%s\n",getenv(argv[1]));
    } else { // they did it wrong
        printf("Usage: printenv <1 variable>\n");
    }

}
