/*
* File:     process.c
* Author:   Michael Chinn
* UDel ID:  mechinn
*/

/*
 * When given just a pid sends a SIGTERM to it with kill(2).
 * When given a signal number (with a - in front of it) sends that
 * signal to the pid. (ex. kill 5678, kill -9 5678)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>

#include "process.h"
// main kill function (kill exists and process made more sense to me)
void process(int argc, char **argv) {
    // setup variables
    char* sigs;
    pid_t pid;
    int sign;
    printf ("check what to kill\n");
    if ((argc==3)&&(!strncmp(argv[1],"-",1))) { // if the user gave signal and pid
        char* sigs = strtok(argv[1], "-"); //get -#
        sign = atoi(sigs); //make the sig an actual int we can deal with
        pid = atoi(argv[2]); // make the pid an actual int we can deal with
        printf ("sig %d to %d\n",sign,pid); // tell the user what they just did
        if (kill(pid, sign) == -1) { //send signal to process
            perror("kill");
        }
    } else if ((argc==2)&&(strncmp(argv[1],"-",1))) { //if user just gave pid
        pid = atoi(argv[1]); // make the pid an actual int we can deal with
        printf ("killing %d\n",pid); // tell the user what they just did
        if (kill(pid, 9) == -1) { //kill the process
            perror("kill");
        }
    } else { // they did it wrong
        printf ("Usage: kill <-sig> pid");
    }
}
