/*
* File:     where.c
* Author:   Michael Chinn
* UDel ID:  mechinn
*/

// same as the tcsh one

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>

#include "get_path.h"
#include "alias.h"
#include "where.h"

//main where (print path and alias)
void where(int argc, char **argv, char** envp){
    if (argc>1) { //if the user gave something to find
        int i;
        for(i=1;i<argc;++i){ //for each of the arguments after where
            // check if it is an internal process
            if ((!strncmp(argv[i],"exit",4)||!strncmp(argv[i],"which",5)||!strncmp(argv[i],"where",5)||!strncmp(argv[i],"cd",2)||!strncmp(argv[i],"pwd",3)||!strncmp(argv[i],"list",4)||!strncmp(argv[i],"pid",3)||!strncmp(argv[i],"kill",4)||!strncmp(argv[i],"prompt",6)||!strncmp(argv[i],"printenv",8)||!strncmp(argv[i],"alias",5)||!strncmp(argv[i],"history",7)||!strncmp(argv[i],"setnenv",7))) {
                printf ("%s: Shell built in command\n",argv[i]);
            }
            char *command;
            struct pathelement *pathlist, *pathfind;
            pathlist = get_path();
            // check if it is a direct path
            if (!strncmp(argv[i],"/",i)||!strncmp(argv[i],"./",2)||!strncmp(argv[i],"../",3)) {
                if (access(argv[i], X_OK) == -1) {
                    perror( "access" );
                } else {
                    printf ("%s\n",argv[i]);
                }
            } else {
                //go through the path and see if it exists
                pathfind = pathlist;
                while ( pathfind && pathfind->element){/* loop through the linked list */
                    // concatinate path and command
                    int elementLength = strlen(pathfind->element);
                    command = malloc((elementLength+strlen(argv[i])+1)*sizeof(char));
                    strncpy(command, pathfind->element, elementLength);
                    command[elementLength] = '/';
                    strncat(command,argv[i],strlen(argv[i]));
                    //check if the access is available
                    if (access(command, X_OK) == -1) {
                        pathfind = pathfind->next;
                    } else {
                        //print out the full path that does exist and we can execute
                        printf ("%s\n",command);
                        pathfind = pathfind->next;
                    }
                }
                free(command);
                // go through aliases
                struct aliasList *temp = aliasHead;
                while(temp) {
                    if(!strncmp(argv[i],temp->name,strlen(temp->name))){
                        printf ("Alias: %s == %s\n",temp->name,temp->command);
                    }
                    temp = temp->next;
                }
            }
            freePath(pathlist);
        }
    } else { // they did it wrong
        printf("Usage: where <command/alias1 command/alias2 ...>");
    }
}
