/*
* File:     which.c
* Author:   Michael Chinn
* UDel ID:  mechinn
*/

// same as the tcsh one

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>

#include "get_path.h"
#include "which.h"

//main which
void which(int argc, char **argv, char** envp){
    if(argc>1) { //which has args
        int i;
        for(i=1;i<argc;++i){ // go through the args
            // check if it is an internal command
            if ((!strncmp(argv[i],"exit",4)||!strncmp(argv[i],"which",5)||!strncmp(argv[i],"where",5)||!strncmp(argv[i],"cd",2)||!strncmp(argv[i],"pwd",3)||!strncmp(argv[i],"list",4)||!strncmp(argv[i],"pid",3)||!strncmp(argv[i],"kill",4)||!strncmp(argv[i],"prompt",6)||!strncmp(argv[i],"printenv",8)||!strncmp(argv[i],"alias",5)||!strncmp(argv[i],"history",7)||!strncmp(argv[i],"setnenv",7))) {
                printf ("%s: Shell built in command\n",argv[i]);
            } else {
                //if direct path
                if (!strncmp(argv[i],"/",i)||!strncmp(argv[i],"./",2)||!strncmp(argv[i],"../",3)) {
                    if (access(argv[i], X_OK) == -1) {
                        perror( "access" );
                    } else {
                        printf ("%s\n",argv[i]);
                    }
                } else {
                    // not direct path so check through path
                    char *command;
                    struct pathelement *pathlist, *pathfind;
                    pathlist = get_path();
                    pathfind = pathlist;
                    while ( pathfind && pathfind->element){/* loop through the linked list */
                        //concatinate path and command
                        int elementLength = strlen(pathfind->element);
                        command = malloc((elementLength+strlen(argv[i])+1)*sizeof(char));
                        strncpy(command, pathfind->element, elementLength);
                        command[elementLength] = '/';
                        strncat(command,argv[i],strlen(argv[i]));
                        //check if we can execute the file
                        if (access(command, X_OK) == -1) {
                            pathfind = pathfind->next;
                        } else {
                            printf ("%s\n",command);
                            break;
                        }
                    }
                    free(command); //free memory for command
                    freePath(pathlist); //free the pathlist
                }
            }
        }
    } else { //they did it wrong
        printf("Usage: which <command>");
    }
}
